using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 附件表
    /// </summary>
    public partial class T_Sys_Accessories
    {
        public T_Sys_Accessories()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_FileId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Accessories");
            strSql.Append(" where F_FileId=@F_FileId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_FileId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Accessories model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Accessories(");
            strSql.Append("F_FileName,F_FileType,F_FileUrl,F_UserCode,F_AddTime,F_Size,F_OriName)");
            strSql.Append(" values (");
            strSql.Append("@F_FileName,@F_FileType,@F_FileUrl,@F_UserCode,@F_AddTime,@F_Size,@F_OriName)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_FileName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_FileType", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileUrl", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Size", SqlDbType.BigInt,8),
                    new SqlParameter("@F_OriName", SqlDbType.NVarChar,500)
            };
            parameters[0].Value = model.F_FileName;
            parameters[1].Value = model.F_FileType;
            parameters[2].Value = model.F_FileUrl;
            parameters[3].Value = model.F_UserCode;
            parameters[4].Value = model.F_AddTime;
            parameters[5].Value = model.F_Size;
            parameters[6].Value = model.F_OriName;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Accessories model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Accessories set ");
            strSql.Append("F_FileName=@F_FileName,");
            strSql.Append("F_FileType=@F_FileType,");
            strSql.Append("F_FileUrl=@F_FileUrl,");
            strSql.Append("F_UserCode=@F_UserCode,");
            strSql.Append("F_AddTime=@F_AddTime,");
            strSql.Append("F_Size=@F_Size,"); 
            strSql.Append("F_OriName=@F_OriName ");
            strSql.Append(" where F_FileId=@F_FileId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_FileName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_FileType", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileUrl", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Size", SqlDbType.BigInt,8),
                    new SqlParameter("@F_OriName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_FileName;
            parameters[1].Value = model.F_FileType;
            parameters[2].Value = model.F_FileUrl;
            parameters[3].Value = model.F_UserCode;
            parameters[4].Value = model.F_AddTime;
            parameters[5].Value = model.F_Size;
            parameters[6].Value = model.F_OriName;
            parameters[7].Value = model.F_FileId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_FileId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Accessories ");
            strSql.Append(" where F_FileId=@F_FileId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_FileId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_FileIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Accessories ");
            strSql.Append(" where F_FileId in (" + F_FileIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Accessories GetModel(int F_FileId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Sys_Accessories ");
            strSql.Append(" where F_FileId=@F_FileId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_FileId;

            CallCenterApi.Model.T_Sys_Accessories model = new CallCenterApi.Model.T_Sys_Accessories();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Accessories DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Accessories model = new CallCenterApi.Model.T_Sys_Accessories();
            if (row != null)
            {
                if (row["F_FileId"] != null && row["F_FileId"].ToString() != "")
                {
                    model.F_FileId = int.Parse(row["F_FileId"].ToString());
                }
                if (row["F_FileName"] != null)
                {
                    model.F_FileName = row["F_FileName"].ToString();
                }
                if (row["F_FileType"] != null)
                {
                    model.F_FileType = row["F_FileType"].ToString();
                }
                if (row["F_FileUrl"] != null)
                {
                    model.F_FileUrl = row["F_FileUrl"].ToString();
                }
                if (row["F_UserCode"] != null)
                {
                    model.F_UserCode = row["F_UserCode"].ToString();
                }
                if (row["F_AddTime"] != null && row["F_AddTime"].ToString() != "")
                {
                    model.F_AddTime = DateTime.Parse(row["F_AddTime"].ToString());
                }
                if (row["F_Size"] != null && row["F_Size"].ToString() != "")
                {
                    model.F_Size = long.Parse(row["F_Size"].ToString());
                }
                if (row["F_OriName"] != null)
                {
                    model.F_OriName = row["F_OriName"].ToString();
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Sys_Accessories ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Sys_Accessories ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Accessories ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_FileId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Accessories T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Accessories";
			parameters[1].Value = "F_FileId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
